const { parse } = require("../../src/utils/parser.js");
const { removeSpaces, validator } = require("../../src/utils/validator.js");


test('removeSpaces could work correctly', () => {

    inputString = "|-!A & B";

    const output = removeSpaces(inputString);

    expect(output).toEqual("|-!A&B");
});

// valid
test('validator could work correctly', () => {

    userString = "|-!A & B";

    output = validator(parse(userString), removeSpaces(userString));

    expect(output[0]).toEqual(true);
});

test('validator could work correctly', () => {

    userString = "|-(A -> B) || C";

    output = validator(parse(userString), removeSpaces(userString));

    expect(output[0]).toEqual(true);
});

// invalid
test('validator could work correctly', () => {

    standardAst = parse("|-A&B");
    userString = "|-!A & B";

    output = validator(standardAst, removeSpaces(userString));

    expect(output[0]).toEqual(false);
    expect(output[1]).toEqual(`The student's answer is incorrect at character [3]: '!'`);
});

test('validator could work correctly', () => {

    standardAst = parse("|-A&B");
    userString = "|-A || B";

    output = validator(standardAst, removeSpaces(userString));

    expect(output[0]).toEqual(false);
    expect(output[1]).toEqual(`The student's answer is incorrect at character [4]: '|'`);
});

test('validator could work correctly', () => {

    standardAst = parse("|-(A -> B) || C");
    userString = "|-A -> B || C";

    output = validator(standardAst, removeSpaces(userString));

    expect(output[0]).toEqual(false);
    expect(output[1]).toEqual(`The student's answer is incorrect at character [3]: 'A'`);
});


